#ifndef __ANATCONFORM_H__
#define __ANATCONFORM_H__

#include "Rinterface.h"
#include "anatconForm.h"

#include <vector>

using namespace std;

class anatcon : public anatconForm {
  Q_OBJECT

public:
  anatcon( Rinterface *pipe, QWidget* parent = 0, const char* name = 0, 
           bool modal = false, WFlags fl = 0 );
  void traceConnectivity( int vertexNumber );
  ~anatcon();
public slots:
  // slots
  void messageReceived( QString );
  void removeRegression();
  void setCortex( QString newCortex ) { *cortex = newCortex; };
  void receivePaintedVertices( vector<int> indices );
  void startTraceFromLabel();
  void traceFromLabel();
signals:
  void newDataFile( QString );
  void getPaintedVertices( int vertexNumber );
  void areaTraceReady();

private:
  Rinterface *pipe;
  QString *cortex;

};

#endif // __ANATCONFORM_H__
