#include "callbacks.h"

#include <Inventor/nodes/SoIndexedFaceSet.h>
#include <Inventor/nodes/SoSwitch.h>

#ifdef Point
#undef Point
#endif

void mouseButtonEventCB( void *userData, SoEventCallback *eventCB ) {
  const SoEvent *event = eventCB->getEvent();
  brainApp *app = (brainApp *) userData;
  SoTexture2Transform *tTrans;
  SbVec2f scale;
  SbBool haveTexture = TRUE;



  SoSeparator *separator = 
    (SoSeparator *) app->objViewer->getSceneManager()->getSceneGraph();


  if (SO_MOUSE_PRESS_EVENT(event, BUTTON1) && 
      app->clipSwitch->whichChild.getValue() == SO_SWITCH_NONE) {
    const SbViewportRegion &viewportRegion = 
      eventCB->getAction()->getViewportRegion();


    if (tTrans != NULL)
      scale = app->textureTrans->scaleFactor.getValue();
    else
      haveTexture = FALSE;

    app->picker->pickPointFromViewport( separator, viewportRegion, 
                                        event->getPosition(viewportRegion),
                                        haveTexture,
                                        scale, app->currentMin);

 
    eventCB->setHandled();
  }
}


/*
 * Somewhat of a test function - what it does for now is intercept
 * the plus and minus keys and change the scaling on the texture 
 * map.
 */

SbBool viewerOverrideCB( void *userData, QEvent *anyevent ) {
    brainApp *app = (brainApp *) userData;

    SbVec2f scale;

    QKeyEvent *myKeyEvent;

    SbBool handled = FALSE;
    float changeByValue = 0.005;
  
    //cout << anyevent->type() << " " << anyevent->KeyPress << endl;

    if ( anyevent->type() == anyevent->KeyPress ) { 
      // should be anyevent->KeyPress, but that
      // gives strange compile errors.
      //      if (app->textureTrans != NULL) {
      myKeyEvent = (QKeyEvent *) anyevent;
//        scale = app->textureTrans->scaleFactor.getValue();

//        if ( myKeyEvent->ascii() == Qt::Key_Plus ) { 
//          scale[1] += changeByValue;
//        }
//        else if ( myKeyEvent->ascii() == Qt::Key_Minus) {
//          scale[1] -= changeByValue;
//        }

      /* Supposed to print the screen to a postscript file. At this point,
       * however, it only prints a pretty black box. I have no idea why.
       */
      if ( myKeyEvent->ascii() == Qt::Key_P ) {

	FILE *fp = fopen("test.ps", "w+");
    cout << "Dumping file ..." << endl;
        
	// Create a viewport to render the scene into.
	const SbViewportRegion &vp = app->objViewer->getViewportRegion();
	const SbVec2s &imagePixSize = vp.getViewportSizePixels();
	
	SbVec2f imageInches;
	float pixPerInch;
	
	pixPerInch = SoOffscreenRenderer::getScreenPixelsPerInch();
	imageInches.setValue((float)imagePixSize[0] / pixPerInch,
			     (float)imagePixSize[1] / pixPerInch);
	
	// The resolution to render the scene for the printer
	// is equal to the size of the image in inches times
	// the printer DPI;
	SbVec2s postScriptRes;
	
	int printerDPI = 75;
	
	postScriptRes.setValue((short)(imageInches[0]*printerDPI),
			       (short)(imageInches[1]*printerDPI));
	
	// Create a viewport to render the scene into.
	SbViewportRegion myViewport;
	myViewport.setWindowSize(postScriptRes);
	myViewport.setPixelsPerInch((float)printerDPI);
	
	SoOffscreenRenderer *renderer = new SoOffscreenRenderer(myViewport);
	
	renderer->render(app->objViewer->getSceneGraph());
	renderer->writeToPostScript(fp);
        
	delete renderer;
	
	fclose(fp);
      }
//        app->textureTrans->scaleFactor.setValue(scale);
//        char *tmp = new char[6];
//        sprintf(tmp, "%.2f",(1 / scale[1]));
//        app->highColourmapValue->string = tmp;
//        sprintf(tmp, "%.2f",(1 / scale[1])* 0.75);
//        app->threeQColourmapValue->string = tmp;
//        delete tmp;
//      }

//      break;
//    default:
//      handled = FALSE;
	//	break;
	//      }
    }
  return FALSE;
}






